module profile.model;

import profile.data;

/**
 * A profile is a complete set of Finnow financial data, all stored in one
 * single database file. The profile's name is used to lookup the database
 * partition for its data. A user may own multiple profiles.
 */
class Profile {
    string name;

    this(string name) {
        this.name = name;
    }

    override int opCmp(Object other) const {
        if (Profile p = cast(Profile) other) {
            return this.name < p.name;
        }
        return 1;
    }
}

struct ProfileProperty {
    string property;
    string value;
}
